// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: connectrpc/questions/v1/questions.proto

package questionsv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/questions/pkg/gen/connectrpc/questions/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// QuestionsServiceName is the fully-qualified name of the QuestionsService service.
	QuestionsServiceName = "connectrpc.questions.v1.QuestionsService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// QuestionsServiceGenerateQuestionSetProcedure is the fully-qualified name of the
	// QuestionsService's GenerateQuestionSet RPC.
	QuestionsServiceGenerateQuestionSetProcedure = "/connectrpc.questions.v1.QuestionsService/GenerateQuestionSet"
	// QuestionsServiceGetQuestionSetProcedure is the fully-qualified name of the QuestionsService's
	// GetQuestionSet RPC.
	QuestionsServiceGetQuestionSetProcedure = "/connectrpc.questions.v1.QuestionsService/GetQuestionSet"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	questionsServiceServiceDescriptor                   = v1.File_connectrpc_questions_v1_questions_proto.Services().ByName("QuestionsService")
	questionsServiceGenerateQuestionSetMethodDescriptor = questionsServiceServiceDescriptor.Methods().ByName("GenerateQuestionSet")
	questionsServiceGetQuestionSetMethodDescriptor      = questionsServiceServiceDescriptor.Methods().ByName("GetQuestionSet")
)

// QuestionsServiceClient is a client for the connectrpc.questions.v1.QuestionsService service.
type QuestionsServiceClient interface {
	GenerateQuestionSet(context.Context, *connect.Request[v1.GenerateQuestionSetRequest]) (*connect.Response[v1.GenerateQuestionSetResponse], error)
	GetQuestionSet(context.Context, *connect.Request[v1.GetQuestionSetRequest]) (*connect.Response[v1.GetQuestionSetResponse], error)
}

// NewQuestionsServiceClient constructs a client for the connectrpc.questions.v1.QuestionsService
// service. By default, it uses the Connect protocol with the binary Protobuf Codec, asks for
// gzipped responses, and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply
// the connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewQuestionsServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) QuestionsServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &questionsServiceClient{
		generateQuestionSet: connect.NewClient[v1.GenerateQuestionSetRequest, v1.GenerateQuestionSetResponse](
			httpClient,
			baseURL+QuestionsServiceGenerateQuestionSetProcedure,
			connect.WithSchema(questionsServiceGenerateQuestionSetMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getQuestionSet: connect.NewClient[v1.GetQuestionSetRequest, v1.GetQuestionSetResponse](
			httpClient,
			baseURL+QuestionsServiceGetQuestionSetProcedure,
			connect.WithSchema(questionsServiceGetQuestionSetMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// questionsServiceClient implements QuestionsServiceClient.
type questionsServiceClient struct {
	generateQuestionSet *connect.Client[v1.GenerateQuestionSetRequest, v1.GenerateQuestionSetResponse]
	getQuestionSet      *connect.Client[v1.GetQuestionSetRequest, v1.GetQuestionSetResponse]
}

// GenerateQuestionSet calls connectrpc.questions.v1.QuestionsService.GenerateQuestionSet.
func (c *questionsServiceClient) GenerateQuestionSet(ctx context.Context, req *connect.Request[v1.GenerateQuestionSetRequest]) (*connect.Response[v1.GenerateQuestionSetResponse], error) {
	return c.generateQuestionSet.CallUnary(ctx, req)
}

// GetQuestionSet calls connectrpc.questions.v1.QuestionsService.GetQuestionSet.
func (c *questionsServiceClient) GetQuestionSet(ctx context.Context, req *connect.Request[v1.GetQuestionSetRequest]) (*connect.Response[v1.GetQuestionSetResponse], error) {
	return c.getQuestionSet.CallUnary(ctx, req)
}

// QuestionsServiceHandler is an implementation of the connectrpc.questions.v1.QuestionsService
// service.
type QuestionsServiceHandler interface {
	GenerateQuestionSet(context.Context, *connect.Request[v1.GenerateQuestionSetRequest]) (*connect.Response[v1.GenerateQuestionSetResponse], error)
	GetQuestionSet(context.Context, *connect.Request[v1.GetQuestionSetRequest]) (*connect.Response[v1.GetQuestionSetResponse], error)
}

// NewQuestionsServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewQuestionsServiceHandler(svc QuestionsServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	questionsServiceGenerateQuestionSetHandler := connect.NewUnaryHandler(
		QuestionsServiceGenerateQuestionSetProcedure,
		svc.GenerateQuestionSet,
		connect.WithSchema(questionsServiceGenerateQuestionSetMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	questionsServiceGetQuestionSetHandler := connect.NewUnaryHandler(
		QuestionsServiceGetQuestionSetProcedure,
		svc.GetQuestionSet,
		connect.WithSchema(questionsServiceGetQuestionSetMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/connectrpc.questions.v1.QuestionsService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case QuestionsServiceGenerateQuestionSetProcedure:
			questionsServiceGenerateQuestionSetHandler.ServeHTTP(w, r)
		case QuestionsServiceGetQuestionSetProcedure:
			questionsServiceGetQuestionSetHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedQuestionsServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedQuestionsServiceHandler struct{}

func (UnimplementedQuestionsServiceHandler) GenerateQuestionSet(context.Context, *connect.Request[v1.GenerateQuestionSetRequest]) (*connect.Response[v1.GenerateQuestionSetResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.questions.v1.QuestionsService.GenerateQuestionSet is not implemented"))
}

func (UnimplementedQuestionsServiceHandler) GetQuestionSet(context.Context, *connect.Request[v1.GetQuestionSetRequest]) (*connect.Response[v1.GetQuestionSetResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.questions.v1.QuestionsService.GetQuestionSet is not implemented"))
}
